diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_user.c ircd-hybrid-fuis/src/s_user.c
--- ircd-hybrid-7.0rc9/src/s_user.c	Sun Feb 16 17:54:37 2003
+++ ircd-hybrid-fuis/src/s_user.c	Sun Apr 13 12:18:57 2003
@@ -55,7 +55,7 @@
 
 static int valid_hostname(const char* hostname);
 static int valid_username(const char* username);
-static void report_and_set_user_flags( struct Client *, struct ConfItem * );
+static void report_and_set_user_flags( struct Client *, struct ConfItem *, int );
 static int check_X_line(struct Client *client_p, struct Client *source_p);
 void user_welcome(struct Client *source_p);
 static int introduce_client(struct Client *client_p, struct Client *source_p,
@@ -86,11 +86,18 @@
   {FLAGS_OPER, 'o'},
   {FLAGS_REJ, 'r'},
   {FLAGS_SERVNOTICE, 's'},
+  {FLAGS_SILENCE, 'S'},
+  {FLAGS_NOLIST, 'X'},
+  {FLAGS_AVFH, 'h'},
   {FLAGS_UNAUTH, 'u'},
   {FLAGS_WALLOP, 'w'},
   {FLAGS_EXTERNAL, 'x'},
   {FLAGS_SPY, 'y'},
   {FLAGS_OPERWALL, 'z'},
+  {FLAGS_TRANSWIN, 'T'},
+  {FLAGS_TRANSISO, 'Y'},
+  {FLAGS_NODCC, 'D'},
+  {FLAGS_NOIDLE, 'I'},
   {0, 0}
 };
 
@@ -106,12 +113,12 @@
   0,            /* A */
   0,            /* B */
   0,            /* C */
-  0,            /* D */
+  FLAGS_NODCC,  /* D */
   0,            /* E */
   0,            /* F */
   0,            /* G */
   0,            /* H */
-  0,            /* I */
+  FLAGS_NOIDLE, /* I */
   0,            /* J */
   0,            /* K */
   0,            /* L */
@@ -121,13 +128,13 @@
   0,            /* P */
   0,            /* Q */
   0,            /* R */
-  0,            /* S */
-  0,            /* T */
+  FLAGS_SILENCE,/* S */
+  FLAGS_TRANSWIN,/* T */
   0,            /* U */
   0,            /* V */
   0,            /* W */
-  0,            /* X */
-  0,            /* Y */
+  FLAGS_NOLIST,/* X */
+  FLAGS_TRANSISO, /* Y */
   0,            /* Z 0x5A */
   0, 0, 0, 0, 0, /* 0x5F */ 
   /* 0x60 */       0,
@@ -138,7 +145,7 @@
   0,            /* e */
   FLAGS_FULL,   /* f */
   FLAGS_CALLERID,  /* g */
-  0,            /* h */
+  FLAGS_AVFH,   /* h */
   FLAGS_INVISIBLE, /* i */
   0,            /* j */
   FLAGS_SKILL,  /* k */
@@ -215,6 +222,9 @@
   sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, source_p->name,
              Count.total, Count.max_tot);
 
+  sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, source_p->name,
+             CurrentIdentUsers, MaxIdentUsers);
+
   if(!ConfigServerHide.hide_servers || IsOper(source_p))
     sendto_one(source_p, form_str(RPL_STATSCONN), me.name, source_p->name,
                MaxConnectionCount, MaxClientCount, Count.totalrestartcount);
@@ -284,7 +294,7 @@
   struct User*     user = source_p->user;
   char        tmpstr2[IRCD_BUFSIZE];
   char	      ipaddr[HOSTIPLEN];
-  int  status;
+  int  status, badpass = 0;
   dlink_node *ptr;
   dlink_node *m;
   char *id;
@@ -300,27 +310,26 @@
 
   if(ConfigFileEntry.ping_cookie)
   {
-    if(!IsPingSent(source_p) &&
-       source_p->localClient->random_ping == 0)
-    {
+  	if(!IsPingSent(source_p) &&
+	   source_p->localClient->random_ping == 0)
+  	{
       source_p->localClient->random_ping = (unsigned long)rand();
       sendto_one(source_p,
-		 "PING :%lu",
-		 (unsigned long)source_p->localClient->random_ping);
+	   "PING :%lu",
+	   (unsigned long)source_p->localClient->random_ping);
       SetPingSent(source_p);
-      return -1;
-    } 
-    if(!(source_p->flags2 & FLAGS2_PING_COOKIE))
-    {
-      return -1;
-    }
+  	  return -1;
+  	} 
+  	if(!(source_p->flags2 & FLAGS2_PING_COOKIE))
+  	{
+  	   return -1;
+  	}
   }
  
   user->last = CurrentTime;
   /* Straight up the maximum rate of flooding... */
   source_p->localClient->allow_read = MAX_FLOOD_BURST;
 
-
   if( ( status = check_client(client_p, source_p, username )) < 0 )
     return(CLIENT_EXITED);
 
@@ -340,6 +349,9 @@
     return(CLIENT_EXITED);
   }
 
+  if (IsConfWebChat(aconf))
+	strlcpy(source_p->host, source_p->realhost, sizeof(source_p->host));
+
   if (!IsGotId(source_p))
     {
       char *p;
@@ -373,17 +385,25 @@
   /* password check */
   if (!BadPtr(aconf->passwd) &&
       strcmp(source_p->localClient->passwd, aconf->passwd))
-  {
-    ServerStats->is_ref++;
-    sendto_one(source_p, form_str(ERR_PASSWDMISMATCH),
-               me.name, source_p->name);
-    exit_client(client_p, source_p, &me, "Bad Password");
-    return(CLIENT_EXITED);
-  }
+    {
+	  if (IsConfSkipOnPassFail(aconf)) {
+		if (IsConfDoSpoofIp(aconf))
+		  strcpy(source_p->host, source_p->realhost);
+		sendto_one(source_p, ":%s NOTICE %s :You've given a bad password, but I'll bypass you with your normal host.",
+				   me.name, source_p->name);
+		badpass = 1;
+	  } else {
+  	    ServerStats->is_ref++;
+  	    sendto_one(source_p, form_str(ERR_PASSWDMISMATCH),
+		   me.name, source_p->name);
+    	exit_client(client_p, source_p, &me, "Bad Password");
+    	return(CLIENT_EXITED);
+	  }
+    }
   memset(source_p->localClient->passwd,0, sizeof(source_p->localClient->passwd));
 
   /* report if user has &^>= etc. and set flags as needed in source_p */
-  report_and_set_user_flags(source_p, aconf);
+  report_and_set_user_flags(source_p, aconf, badpass);
   
   /* Limit clients */
   /*
@@ -495,6 +515,53 @@
     exit_client(client_p, source_p, &me, "Client exited");
     return CLIENT_EXITED;
   }
+
+  if (!IsConfDoSpoofIp(aconf))
+    strcpy(source_p->realhost, source_p->host);
+
+  /* mask the appropriate client host portion:
+   * - leftmost part if resolving host
+   *   (but not if just one dot in the host)
+   * - rightmost part if numeric IP
+   *                                   -demond
+   */
+  if (IsConfMaskHost(aconf) && ((badpass == 1 && IsConfDoSpoofIp(aconf)) || !IsConfDoSpoofIp(aconf)))
+    {
+      int alpha = 0, dots = 0;
+      char buf[HOSTLEN + 1];
+      char *p = source_p->host;
+      static char *get_mask(char *, int);
+
+      while (*p)
+	  {
+    	if (isalpha(*p)) alpha = 1;
+    	if (*p++ == '.') ++dots;
+  	  }
+
+      strcpy(buf, source_p->host);
+
+      if (alpha && (dots > 1))
+	  {
+    	p = strchr(buf, '.'); *p++ = 0;
+
+    	if (strlen(p) + MAXNETID + 6 <= HOSTLEN)
+        {
+          strcpy(source_p->host, get_mask(buf, 0));
+          strcat(source_p->host, p);
+        }
+  	  }
+      else if (!alpha)
+  	  {
+    	p = strrchr(buf, '.'); *p++ = 0;
+
+    	if (strlen(buf) + 7 <= HOSTLEN)
+        {
+          strcpy(source_p->host, buf);
+          strcat(source_p->host, get_mask(NULL, atoi(p)));
+        }
+  	  }
+    }
+
   user_welcome(source_p);
 
   return (introduce_client(client_p, source_p, user, nick));
@@ -634,22 +701,26 @@
     {
       if (IsCapable(uplink, CAP_UID) && HasID(source_p))
 	{
-	  sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s :%s",
+	  sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s %s :%s",
 		     nick,
 		     source_p->hopcount+1,
 		     (unsigned long) source_p->tsinfo,
 		     ubuf,
-		     source_p->username, source_p->host, user->server,
-		     user->id, source_p->info);
+		     source_p->username, source_p->host, user->server, user->id,
+			 IsCapable(uplink, CAP_HOSTMASK)?
+			 source_p->realhost[0] ? source_p->realhost : "" : "",
+			 source_p->info);
 	}
       else
 	{
-	  sendto_one(uplink, "NICK %s %d %lu %s %s %s %s :%s",
+	  sendto_one(uplink, "NICK %s %d %lu %s %s %s %s %s :%s",
 		     nick,
 		     source_p->hopcount+1,
 		     (unsigned long) source_p->tsinfo,
 		     ubuf,
 		     source_p->username, source_p->host, user->server,
+			 IsCapable(uplink, CAP_HOSTMASK)?
+			 source_p->realhost[0] ? source_p->realhost : "" :"",
 		     source_p->info);
 	}
     }
@@ -661,22 +732,27 @@
 		  
 	  if (IsCapable(server, CAP_LL) || server == client_p)
 	    continue;
-		  
+  
 	  if (IsCapable(server, CAP_UID) && HasID(source_p))
-	    sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s :%s",
+	    sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s %s :%s",
 		       nick,
 		       source_p->hopcount+1,
 		       (unsigned long) source_p->tsinfo,
 		       ubuf,
 		       source_p->username, source_p->host, user->server,
-		       user->id, source_p->info);
+		       user->id,
+	           IsCapable(server, CAP_HOSTMASK)?
+			   source_p->realhost[0] ? source_p->realhost : "" : "",
+	  		   source_p->info);
 	  else
-	    sendto_one(server, "NICK %s %d %lu %s %s %s %s :%s",
+	    sendto_one(server, "NICK %s %d %lu %s %s %s %s %s :%s",
 		       nick,
 		       source_p->hopcount+1,
 		       (unsigned long) source_p->tsinfo,
 		       ubuf,
 		       source_p->username, source_p->host, user->server,
+	           IsCapable(server, CAP_HOSTMASK)?
+			   source_p->realhost[0] ? source_p->realhost : "":"",
 		       source_p->info);
 	}
     }
@@ -775,10 +851,10 @@
  */
 
 static void 
-report_and_set_user_flags(struct Client *source_p,struct ConfItem *aconf)
+report_and_set_user_flags(struct Client *source_p,struct ConfItem *aconf, int badpass)
 {
   /* If this user is being spoofed, tell them so */
-  if(IsConfDoSpoofIp(aconf))
+  if(IsConfDoSpoofIp(aconf) && badpass == 0)
     {
       sendto_one(source_p,
                  ":%s NOTICE %s :*** Spoofing your IP. congrats.",
@@ -790,17 +866,7 @@
     {
       SetExemptKline(source_p);
       sendto_one(source_p,
-         ":%s NOTICE %s :*** You are exempt from K/D/G lines. congrats.",
-                 me.name,source_p->name);
-    }
-  /* The else here is to make sure that G line exempt users
-   * do not get noticed twice.
-   */
-  else if (IsConfExemptGline(aconf))
-    {
-      SetExemptGline(source_p);
-      sendto_one(source_p,
-         ":%s NOTICE %s :*** You are exempt from G lines.",
+         ":%s NOTICE %s :*** You are exempt from K/D lines. congrats.",
                  me.name,source_p->name);
     }
 
@@ -843,6 +909,8 @@
 		  char* username, char *host, char *server, char *realname)
 {
   struct User* user;
+  char *hend = host + strlen(host) - 1;
+  char *send = server + strlen(server) - 1;
 
   assert(NULL != source_p);
   assert(source_p->username != username);
@@ -852,6 +920,12 @@
 
   user = make_user(source_p);
 
+  /* mIRC kludge here */
+  if (*host=='"' && *hend=='"' && *server=='"' && *send=='"')
+	user->known = 1;
+  else
+	user->known = IsUserPar(host, server);
+
   if (!IsUnknown(source_p))
     {
       sendto_one(source_p, form_str(ERR_ALREADYREGISTRED), me.name, nick);
@@ -874,8 +948,11 @@
       strlcpy(source_p->username, username, sizeof(source_p->username));
   }
 
+  /* fucking webchat _)_ */
+  strlcpy(source_p->realhost, host, sizeof(source_p->realhost));
+
   if (source_p->name[0])
-  { 
+  {
     /* NICK already received, now I have USER... */
     	return register_local_user(client_p, source_p, source_p->name, username);
   }
@@ -892,7 +969,7 @@
 int
 do_remote_user(char* nick, struct Client* client_p, struct Client* source_p,
 		   char* username, char *host, char *server, char *realname,
-		   char *id)
+		   char *realhost, char *id)
 {
   unsigned int oflags;
   struct User* user;
@@ -914,7 +991,11 @@
   strlcpy(source_p->info, realname, sizeof(source_p->info));
   if (id != NULL)
     strcpy(source_p->user->id, id);
-  
+  if (realhost)
+    strcpy(source_p->realhost, realhost);
+  else
+	strcpy(source_p->realhost, "<no_realhost_info>");
+
   return register_remote_user(client_p, source_p, source_p->name, username);
 }
 
@@ -1073,6 +1154,31 @@
           break;
         }
 
+  if (MyConnect(source_p) && !(setflags & FLAGS_SILENCE) && (HasSilence(source_p)))
+  {
+	sendto_one(source_p,":%s NOTICE %s :You have put Silence mode on your nickname (+S). You will NOT receive any private messages, ctcps, notices from unregistered (too recently registered) nicknames",
+			   me.name, parv[0]);
+  }
+
+  if (MyConnect(source_p) && (setflags & FLAGS_NODCC) && !(source_p->umodes & FLAGS_NODCC))
+  {
+	sendto_one(source_p,":%s NOTICE %s :You have removed your server protection flag. You can return it by typing /mode %s +D",
+			   me.name, parv[0], parv[0]);
+  }
+
+  if ((source_p->umodes & FLAGS_AVFH) && !IsOper(source_p))
+    {
+	  sendto_one(source_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
+      source_p->umodes &= ~FLAGS_AVFH;
+    }
+
+  if (((source_p->umodes & FLAGS_WALLOP) || (source_p->umodes & FLAGS_OPERWALL))  && !IsOperOperwall(source_p))
+    {
+     sendto_one(source_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
+      source_p->umodes &= ~FLAGS_WALLOP;
+      source_p->umodes &= ~FLAGS_OPERWALL;
+    }
+
   if(badflag)
     sendto_one(source_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
 
@@ -1210,22 +1316,28 @@
   /* This is a duplicate of the NOTICE but see below...*/
   sendto_one(source_p, form_str(RPL_YOURHOST), me.name, source_p->name,
 	     get_listener_name(source_p->localClient->listener), ircd_version);
-  
-#if 0
+
+/*#if 0 by the way.. - FUIS*/
   /*
   ** Don't mess with this one - IRCII needs it! -Avalon
   */
-  /* No one has needed this in years, but I remember when IRCII did!
-   * It sure confused me why my IRCII client hung at start up
-   * when I was writing my first ircd from scratch. ;-)
-   * - Dianora
-   */
   sendto_one(source_p,
 	     "NOTICE %s :*** Your host is %s, running version %s",
 	     source_p->name, get_listener_name(source_p->localClient->listener),
 	     ircd_version);
-#endif
+/* #endif */
+
+  if (!irccmp(me.name, source_p->user->server) && ConfigFileEntry.silence_default)
+  {
+	SetSilence(source_p);
+	sendto_one(source_p,"NOTICE %s :%s (me) have put Silence mode on your nickname (+S), this is by default. You will NOT receive any private messages, ctcps, notices from unregistered (too recently registered) nicknames",
+			   source_p->name, me.name);
+  }
   
+  if (!ServicesOn)
+   sendto_one(source_p,
+     "NOTICE %s :*** Services are temporary down. Please be patient!", source_p->name);
+
   sendto_one(source_p, form_str(RPL_CREATED),me.name,source_p->name,creation);
   sendto_one(source_p, form_str(RPL_MYINFO), me.name, source_p->name,
 	     me.name, ircd_version);
@@ -1243,7 +1355,7 @@
       sendto_one(source_p,
 		 "NOTICE %s :*** Notice -- Please read the motd if you haven't read it",
 		 source_p->name);
-    
+
       sendto_one(source_p, form_str(RPL_MOTDSTART),
 		 me.name, source_p->name, me.name);
     
@@ -1331,7 +1443,7 @@
   int old = (source_p->umodes & ALL_UMODES);
   char *operprivs=NULL;
   dlink_node *ptr;
-  struct ConfItem *found_aconf;
+  struct ConfItem *found_aconf = NULL;
   dlink_node *m;
 
   SetOper(source_p);
@@ -1355,7 +1467,7 @@
           source_p->umodes |= (FLAGS_SERVNOTICE|FLAGS_OPERWALL|FLAGS_WALLOP|FLAGS_LOCOPS) & ALL_UMODES;
         }
     }
-	
+
   Count.oper++;
 
   SetExemptKline(source_p);
@@ -1380,8 +1492,9 @@
     source_p->umodes |= FLAGS_ADMIN;
 
   sendto_realops_flags(FLAGS_ALL, L_ALL,
-		       "%s (%s@%s) is now an operator", source_p->name,
-		       source_p->username, source_p->host);
+		       "%s (%s@%s) is now an operator. Using %s (%s@%s) O: line.",
+			   source_p->name, source_p->username, source_p->host, found_aconf ? found_aconf->name : "Unknown", found_aconf ? found_aconf->user : "Unknown", found_aconf ? found_aconf->host : "Unknown");
+
   send_umode_out(source_p, source_p, old);
   sendto_one(source_p, form_str(RPL_YOUREOPER), me.name, source_p->name);
   sendto_one(source_p, ":%s NOTICE %s :*** Oper privs are %s", me.name,
@@ -1390,3 +1503,40 @@
   
   return(1);
 }
+
+static char *get_mask(char *s, int n)
+{
+  static char buf[MAXNETID + 6];
+  char *p = buf;
+  char *netid = ConfigFileEntry.netid[0]? ConfigFileEntry.netid : "FUIS";
+
+  if (s)
+  {
+    unsigned int h = 0;
+
+    while (*s)
+    {
+      h = (h << 4) - (h + (unsigned char)ToLower(*s++));
+    }
+
+    n = h & (U_MAX - 1);
+
+    strcpy(buf, netid);
+    p = buf + strlen(netid);
+  }
+  else
+    *p++ = '.';
+
+  srandom(n);
+
+  for (n = 0; n < 6; n++)
+    *p++ = '0' + random() % 10;
+
+  if (s)
+    *p++ = '.';
+
+  *p = 0;
+
+  return buf;
+}
+
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/tools/convertconf.c ircd-hybrid-fuis/tools/convertconf.c
--- ircd-hybrid-7.0rc9/tools/convertconf.c	Thu Jul 18 11:28:28 2002
+++ ircd-hybrid-fuis/tools/convertconf.c	Sun Feb 16 21:09:38 2003
@@ -797,14 +797,6 @@
 	{
 	  fprintf(out,"\tkline=no;\n");
 	}
-      else if(*privs == 'G')                /* allow gline */
-	{
-	  fprintf(out,"\tgline=yes;\n");
-	}
-      else if(*privs == 'g')                /* disallow gline */
-	{
-	  fprintf(out,"\tgline=no;\n");
-	}
       else if(*privs == 'H')                /* allow rehash */
 	{
 	  fprintf(out,"\trehash=yes;\n");
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/tools/convertilines.c ircd-hybrid-fuis/tools/convertilines.c
--- ircd-hybrid-7.0rc9/tools/convertilines.c	Tue Jul 16 18:30:21 2002
+++ ircd-hybrid-fuis/tools/convertilines.c	Sun Feb 16 21:09:38 2003
@@ -49,7 +49,6 @@
     int restricted;
     int exceed_limit;
     int kline_exempt;
-    int gline_exempt;
     int require_ident;
     int no_tilde;
 
@@ -419,9 +418,6 @@
     if(ptr->kline_exempt)
 	fprintf(out, "\tkline_exempt = yes;\n");
 
-    if(ptr->gline_exempt)
-	fprintf(out, "\tgline_exempt = yes;\n");
-
     if(ptr->no_tilde)
 	fprintf(out, "\tno_tilde = yes;\n");
 
@@ -507,7 +503,6 @@
        (ptr->require_ident == acptr->require_ident) &&
        (ptr->exceed_limit == acptr->exceed_limit) &&
        (ptr->kline_exempt == acptr->kline_exempt) &&
-       (ptr->gline_exempt == acptr->gline_exempt) &&
        (ptr->no_tilde == acptr->no_tilde))
     {
 	char *p1, *p2;
@@ -576,11 +571,6 @@
 
 	  case '>':
 	      ptr->exceed_limit = 1;
-	      ptr->special = 1;
-	      break;
-
-	  case '_':
-	      ptr->gline_exempt = 1;
 	      ptr->special = 1;
 	      break;
 
